static const int duration = 200; //Length of the generated tone (msec)
static const int speaker12 = 12; //speaker pin
static const int switchPin = 2;

static const int scale[] =  {262, 294, 330, 349, 392, 440, 494, 523};
bool scalePlaying = false;

void setup() {
  pinMode(speaker12, OUTPUT);
  pinMode (switchPin, INPUT);

  SerialUSB.begin(9600);

  // QUIZ: what are other values we could use here?
  // Can we avoid using a state variable?
  attachInterrupt (digitalPinToInterrupt (switchPin), SwitchPressed, CHANGE);

}
void loop() {
  if (digitalRead(switchPin) == HIGH) {
    scalePlaying = true;
  }
  else {
    scalePlaying = false;
  }

  playScale();
}

void SwitchPressed() {
  scalePlaying = !scalePlaying;
}


void playScale() {
  if (!scalePlaying) {
    return;
  }

  // this is really not a safe way to get the size of an array.
  // Arduino allows C++ STL
  // https://github.com/maniacbug/StandardCplusplus/blob/master/README.md
 
  for (int i = 0; i < (sizeof(scale) / sizeof(*scale)); i++) {
    // QUIZ: so how do we stop in the middle of the scale?
    if (!scalePlaying) { 
      return;
    }
    tone(speaker12, scale[i], duration);
    delay(duration);
  }
  //  tone(speaker12, 262, duration); // Do
  //  delay(duration);
  //  tone(speaker12, 294, duration); // Re
  //  delay(duration);
  //  tone(speaker12, 330, duration); // Mi
  //  delay(duration);
  //  tone(speaker12, 349, duration); // Fa
  //  delay(duration);
  //  tone(speaker12, 392, duration); // So
  //  delay(duration);
  //  tone(speaker12, 440, duration); // La
  //  delay(duration);
  //  tone(speaker12, 494, duration); // Si
  //  delay(duration);
  //  tone(speaker12, 523, duration); // Do
  //  delay(duration);
}
